using System;
using DevExpress.ExpressApp;
using System.ComponentModel;
using DevExpress.ExpressApp.Web;
using System.Collections.Generic;
using DevExpress.ExpressApp.Xpo;

namespace SampleDynamicProperties.Web {
    // For more typical usage scenarios, be sure to check out http://documentation.devexpress.com/#Xaf/DevExpressExpressAppWebWebApplicationMembersTopicAll
    public partial class SampleDynamicPropertiesAspNetApplication : WebApplication {
        private DevExpress.ExpressApp.SystemModule.SystemModule module1;
        private DevExpress.ExpressApp.Web.SystemModule.SystemAspNetModule module2;
        private SampleDynamicProperties.Module.SampleDynamicPropertiesModule module3;
        private DevExpress.ExpressApp.ConditionalAppearance.ConditionalAppearanceModule conditionalAppearanceModule1;
        private Xafari.XafariModule xafariModule1;
        private DevExpress.ExpressApp.Security.SecurityModule securityModule1;
        private DevExpress.ExpressApp.Validation.ValidationModule validationModule1;
        private Xafari.XF.XafariXFModule xafariXFModule1;
        private Xafari.Editors.XafariEditorsModule xafariEditorsModule1;
        private Xafari.BC.XafariBCModule xafariBCModule1;
        private Xafari.BC.Branches.XafariBCBranchesModule xafariBCBranchesModule1;
        private Xafari.BC.Branches.DC.XafariBCBranchesDCModule xafariBCBranchesDCModule1;
        private Xafari.BC.DC.XafariBCDCModule xafariBCDCModule1;
        private Xafari.BC.Branches.Xpo.XafariBCBranchesXpoModule xafariBCBranchesXpoModule1;
        private Xafari.BC.Xpo.XafariBCXpoModule xafariBCXpoModule1;
        private Xafari.Security.XafariSecurityModule xafariSecurityModule1;
        private Xafari.Security.DC.XafariSecurityDCModule xafariSecurityDCModule1;
        private Xafari.Editors.Web.XafariEditorsWebModule xafariEditorsWebModule1;
        private DevExpress.ExpressApp.TreeListEditors.TreeListEditorsModuleBase treeListEditorsModuleBase1;
        private DevExpress.ExpressApp.TreeListEditors.Web.TreeListEditorsAspNetModule treeListEditorsAspNetModule1;
        private Xafari.BC.Web.XafariBCWebModule xafariBCWebModule1;
        private SampleDynamicProperties.Module.Web.SampleDynamicPropertiesAspNetModule module4;

        public SampleDynamicPropertiesAspNetApplication() {
            InitializeComponent();
        }
        protected override void CreateDefaultObjectSpaceProvider(CreateCustomObjectSpaceProviderEventArgs args) {
            args.ObjectSpaceProvider = new XPObjectSpaceProvider(args.ConnectionString, args.Connection, true);
        }
        private void SampleDynamicPropertiesAspNetApplication_DatabaseVersionMismatch(object sender, DevExpress.ExpressApp.DatabaseVersionMismatchEventArgs e) {
#if EASYTEST
            e.Updater.Update();
            e.Handled = true;
#else
            if(System.Diagnostics.Debugger.IsAttached) {
                e.Updater.Update();
                e.Handled = true;
            }
            else {
                string message = "The application cannot connect to the specified database, because the latter doesn't exist or its version is older than that of the application.\r\n" +
                    "This error occurred  because the automatic database update was disabled when the application was started without debugging.\r\n" +
                    "To avoid this error, you should either start the application under Visual Studio in debug mode, or modify the " +
                    "source code of the 'DatabaseVersionMismatch' event handler to enable automatic database update, " +
                    "or manually create a database using the 'DBUpdater' tool.\r\n" +
                    "Anyway, refer to the following help topics for more detailed information:\r\n" +
                    "'Update Application and Database Versions' at http://help.devexpress.com/#Xaf/CustomDocument2795\r\n" +
                    "'Database Security References' at http://help.devexpress.com/#Xaf/CustomDocument3237\r\n" +
                    "If this doesn't help, please contact our Support Team at http://www.devexpress.com/Support/Center/";

                if(e.CompatibilityError != null && e.CompatibilityError.Exception != null) {
                    message += "\r\n\r\nInner exception: " + e.CompatibilityError.Exception.Message;
                }
                throw new InvalidOperationException(message);
            }
#endif
        }
        private void InitializeComponent() {
            this.module1 = new DevExpress.ExpressApp.SystemModule.SystemModule();
            this.module2 = new DevExpress.ExpressApp.Web.SystemModule.SystemAspNetModule();
            this.module3 = new SampleDynamicProperties.Module.SampleDynamicPropertiesModule();
            this.module4 = new SampleDynamicProperties.Module.Web.SampleDynamicPropertiesAspNetModule();
            this.conditionalAppearanceModule1 = new DevExpress.ExpressApp.ConditionalAppearance.ConditionalAppearanceModule();
            this.xafariModule1 = new Xafari.XafariModule();
            this.securityModule1 = new DevExpress.ExpressApp.Security.SecurityModule();
            this.validationModule1 = new DevExpress.ExpressApp.Validation.ValidationModule();
            this.xafariXFModule1 = new Xafari.XF.XafariXFModule();
            this.xafariEditorsModule1 = new Xafari.Editors.XafariEditorsModule();
            this.xafariBCModule1 = new Xafari.BC.XafariBCModule();
            this.xafariBCBranchesModule1 = new Xafari.BC.Branches.XafariBCBranchesModule();
            this.xafariBCBranchesDCModule1 = new Xafari.BC.Branches.DC.XafariBCBranchesDCModule();
            this.xafariBCDCModule1 = new Xafari.BC.DC.XafariBCDCModule();
            this.xafariBCBranchesXpoModule1 = new Xafari.BC.Branches.Xpo.XafariBCBranchesXpoModule();
            this.xafariBCXpoModule1 = new Xafari.BC.Xpo.XafariBCXpoModule();
            this.xafariSecurityModule1 = new Xafari.Security.XafariSecurityModule();
            this.xafariSecurityDCModule1 = new Xafari.Security.DC.XafariSecurityDCModule();
            this.xafariEditorsWebModule1 = new Xafari.Editors.Web.XafariEditorsWebModule();
            this.treeListEditorsModuleBase1 = new DevExpress.ExpressApp.TreeListEditors.TreeListEditorsModuleBase();
            this.treeListEditorsAspNetModule1 = new DevExpress.ExpressApp.TreeListEditors.Web.TreeListEditorsAspNetModule();
            this.xafariBCWebModule1 = new Xafari.BC.Web.XafariBCWebModule();
            ((System.ComponentModel.ISupportInitialize)(this)).BeginInit();
            // 
            // validationModule1
            // 
            this.validationModule1.AllowValidationDetailsAccess = true;
            this.validationModule1.IgnoreWarningAndInformationRules = false;
            // 
            // SampleDynamicPropertiesAspNetApplication
            // 
            this.ApplicationName = "SampleDynamicProperties";
            this.CollectionsEditMode = DevExpress.ExpressApp.Editors.ViewEditMode.Edit;
            this.Modules.Add(this.module1);
            this.Modules.Add(this.module2);
            this.Modules.Add(this.conditionalAppearanceModule1);
            this.Modules.Add(this.xafariModule1);
            this.Modules.Add(this.securityModule1);
            this.Modules.Add(this.validationModule1);
            this.Modules.Add(this.xafariXFModule1);
            this.Modules.Add(this.xafariEditorsModule1);
            this.Modules.Add(this.xafariSecurityModule1);
            this.Modules.Add(this.xafariBCModule1);
            this.Modules.Add(this.xafariBCBranchesModule1);
            this.Modules.Add(this.xafariSecurityDCModule1);
            this.Modules.Add(this.xafariBCBranchesDCModule1);
            this.Modules.Add(this.xafariBCDCModule1);
            this.Modules.Add(this.xafariBCBranchesXpoModule1);
            this.Modules.Add(this.xafariBCXpoModule1);
            this.Modules.Add(this.module3);
            this.Modules.Add(this.module4);
            this.Modules.Add(this.treeListEditorsModuleBase1);
            this.Modules.Add(this.treeListEditorsAspNetModule1);
            this.Modules.Add(this.xafariEditorsWebModule1);
            this.Modules.Add(this.xafariBCWebModule1);
            this.DatabaseVersionMismatch += new System.EventHandler<DevExpress.ExpressApp.DatabaseVersionMismatchEventArgs>(this.SampleDynamicPropertiesAspNetApplication_DatabaseVersionMismatch);
            ((System.ComponentModel.ISupportInitialize)(this)).EndInit();

        }
    }
}
